# coding: utf-8

"""
    Pathnexus

    Pathnexus - a lab data harmonisation platform  # noqa: E501

    OpenAPI spec version: 5.8.0
    Contact: support@termlex.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from pathnexus.com.termlex.pathnexus.model.codelist_metrics import CodelistMetrics  # noqa: F401,E501
from pathnexus.com.termlex.pathnexus.model.column_metadata import ColumnMetadata  # noqa: F401,E501


class CodeListMetaData(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'column_count': 'int',
        'row_count': 'int',
        'code_list_id': 'str',
        'review_mappings_count': 'int',
        'final_mappings_count': 'int',
        'escalated_mappings_count': 'int',
        'columns': 'list[ColumnMetadata]',
        'metrics': 'CodelistMetrics'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'column_count': 'columnCount',
        'row_count': 'rowCount',
        'code_list_id': 'codeListId',
        'review_mappings_count': 'reviewMappingsCount',
        'final_mappings_count': 'finalMappingsCount',
        'escalated_mappings_count': 'escalatedMappingsCount',
        'columns': 'columns',
        'metrics': 'metrics'
    }

    def __init__(self, id=None, name=None, column_count=None, row_count=None, code_list_id=None, review_mappings_count=None, final_mappings_count=None, escalated_mappings_count=None, columns=None, metrics=None):  # noqa: E501
        """CodeListMetaData - a model defined in Swagger"""  # noqa: E501

        self._id = None
        self._name = None
        self._column_count = None
        self._row_count = None
        self._code_list_id = None
        self._review_mappings_count = None
        self._final_mappings_count = None
        self._escalated_mappings_count = None
        self._columns = None
        self._metrics = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if name is not None:
            self.name = name
        if column_count is not None:
            self.column_count = column_count
        if row_count is not None:
            self.row_count = row_count
        self.code_list_id = code_list_id
        if review_mappings_count is not None:
            self.review_mappings_count = review_mappings_count
        if final_mappings_count is not None:
            self.final_mappings_count = final_mappings_count
        if escalated_mappings_count is not None:
            self.escalated_mappings_count = escalated_mappings_count
        if columns is not None:
            self.columns = columns
        if metrics is not None:
            self.metrics = metrics

    @property
    def id(self):
        """Gets the id of this CodeListMetaData.  # noqa: E501


        :return: The id of this CodeListMetaData.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CodeListMetaData.


        :param id: The id of this CodeListMetaData.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def name(self):
        """Gets the name of this CodeListMetaData.  # noqa: E501


        :return: The name of this CodeListMetaData.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CodeListMetaData.


        :param name: The name of this CodeListMetaData.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def column_count(self):
        """Gets the column_count of this CodeListMetaData.  # noqa: E501


        :return: The column_count of this CodeListMetaData.  # noqa: E501
        :rtype: int
        """
        return self._column_count

    @column_count.setter
    def column_count(self, column_count):
        """Sets the column_count of this CodeListMetaData.


        :param column_count: The column_count of this CodeListMetaData.  # noqa: E501
        :type: int
        """

        self._column_count = column_count

    @property
    def row_count(self):
        """Gets the row_count of this CodeListMetaData.  # noqa: E501


        :return: The row_count of this CodeListMetaData.  # noqa: E501
        :rtype: int
        """
        return self._row_count

    @row_count.setter
    def row_count(self, row_count):
        """Sets the row_count of this CodeListMetaData.


        :param row_count: The row_count of this CodeListMetaData.  # noqa: E501
        :type: int
        """

        self._row_count = row_count

    @property
    def code_list_id(self):
        """Gets the code_list_id of this CodeListMetaData.  # noqa: E501


        :return: The code_list_id of this CodeListMetaData.  # noqa: E501
        :rtype: str
        """
        return self._code_list_id

    @code_list_id.setter
    def code_list_id(self, code_list_id):
        """Sets the code_list_id of this CodeListMetaData.


        :param code_list_id: The code_list_id of this CodeListMetaData.  # noqa: E501
        :type: str
        """
        if code_list_id is None:
            raise ValueError("Invalid value for `code_list_id`, must not be `None`")  # noqa: E501

        self._code_list_id = code_list_id

    @property
    def review_mappings_count(self):
        """Gets the review_mappings_count of this CodeListMetaData.  # noqa: E501


        :return: The review_mappings_count of this CodeListMetaData.  # noqa: E501
        :rtype: int
        """
        return self._review_mappings_count

    @review_mappings_count.setter
    def review_mappings_count(self, review_mappings_count):
        """Sets the review_mappings_count of this CodeListMetaData.


        :param review_mappings_count: The review_mappings_count of this CodeListMetaData.  # noqa: E501
        :type: int
        """

        self._review_mappings_count = review_mappings_count

    @property
    def final_mappings_count(self):
        """Gets the final_mappings_count of this CodeListMetaData.  # noqa: E501


        :return: The final_mappings_count of this CodeListMetaData.  # noqa: E501
        :rtype: int
        """
        return self._final_mappings_count

    @final_mappings_count.setter
    def final_mappings_count(self, final_mappings_count):
        """Sets the final_mappings_count of this CodeListMetaData.


        :param final_mappings_count: The final_mappings_count of this CodeListMetaData.  # noqa: E501
        :type: int
        """

        self._final_mappings_count = final_mappings_count

    @property
    def escalated_mappings_count(self):
        """Gets the escalated_mappings_count of this CodeListMetaData.  # noqa: E501


        :return: The escalated_mappings_count of this CodeListMetaData.  # noqa: E501
        :rtype: int
        """
        return self._escalated_mappings_count

    @escalated_mappings_count.setter
    def escalated_mappings_count(self, escalated_mappings_count):
        """Sets the escalated_mappings_count of this CodeListMetaData.


        :param escalated_mappings_count: The escalated_mappings_count of this CodeListMetaData.  # noqa: E501
        :type: int
        """

        self._escalated_mappings_count = escalated_mappings_count

    @property
    def columns(self):
        """Gets the columns of this CodeListMetaData.  # noqa: E501


        :return: The columns of this CodeListMetaData.  # noqa: E501
        :rtype: list[ColumnMetadata]
        """
        return self._columns

    @columns.setter
    def columns(self, columns):
        """Sets the columns of this CodeListMetaData.


        :param columns: The columns of this CodeListMetaData.  # noqa: E501
        :type: list[ColumnMetadata]
        """

        self._columns = columns

    @property
    def metrics(self):
        """Gets the metrics of this CodeListMetaData.  # noqa: E501


        :return: The metrics of this CodeListMetaData.  # noqa: E501
        :rtype: CodelistMetrics
        """
        return self._metrics

    @metrics.setter
    def metrics(self, metrics):
        """Sets the metrics of this CodeListMetaData.


        :param metrics: The metrics of this CodeListMetaData.  # noqa: E501
        :type: CodelistMetrics
        """

        self._metrics = metrics

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CodeListMetaData):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
